package com.ym.userinfo.module.net

import android.text.TextUtils
import com.ym.library.MyConstant
import com.ym.modulecommon.utils.AdPreference
import okhttp3.*
import okhttp3.logging.HttpLoggingInterceptor
import retrofit2.adapter.rxjava2.RxJava2CallAdapterFactory
import retrofit2.converter.gson.GsonConverterFactory
import java.util.concurrent.TimeUnit

/**
 * Created by gaoleichao on 2018/5/2.
 */
object UserApiClient {

    private val logInterceptor = HttpLoggingInterceptor()
    private val paramsInterceptor = Interceptor { chain ->
        val request = chain.request()
        val builder = request.url().newBuilder()

        if (request.url().toString().contains("yilan")) {
            chain.proceed(request.newBuilder().build())
        } else {
            com.ym.modulecommon.utils.PhoneUtils.addParam(request, builder)
            chain.proceed(request.newBuilder().url(builder.build()).build())
        }
    }

    private val headInterceptor = Interceptor { chain ->
        val request = chain.request()
        val builder = request.newBuilder()
        builder.addHeader(MyConstant.aid, AdPreference.getAndroidId())
        builder.addHeader(MyConstant.Device.env, MyConstant.Param.env)
        if (!TextUtils.isEmpty(AdPreference.getUserAgent())) {
            builder.addHeader("web-user-agent", AdPreference.getUserAgent())
            builder.removeHeader("User-Agent")
            builder.addHeader("User-Agent", AdPreference.getUserAgent())
        }
        val headers: Request = builder.build()
        chain.proceed(headers)
    }

    private val httpClient = okhttp3.OkHttpClient.Builder()
        .connectTimeout(10000, TimeUnit.MILLISECONDS)
        .readTimeout(10000, TimeUnit.MILLISECONDS)
        .addInterceptor(logInterceptor.apply {
            level = HttpLoggingInterceptor.Level.BODY
        })
//        .retryOnConnectionFailure(false)
        .hostnameVerifier { hostname, session ->
            true
        }
        .addInterceptor(paramsInterceptor)
        .addInterceptor(headInterceptor)
        .build()!!

    private val retrofit = retrofit2.Retrofit.Builder()
        .client(httpClient)
        .addCallAdapterFactory(RxJava2CallAdapterFactory.create())
        .addConverterFactory(GsonConverterFactory.create())
        .baseUrl(com.ym.modulecommon.net.NetConfig.BASE_FEED_URL)
        .build()

    val userApi by lazy { retrofit.create(IUserInfoApi::class.java) }
}